<!DOCTYPE html>
<html>

<head>
	<meta charset="UTF-8">
	<title>Classwork</title>
</head>

<body>
	<button id="duration">Duration</button>
	<button id="all">all</button>
	<div id="actors"></div>
	<div id="rez"></div>

	<script>

		/*
		  Задание:
		  1. При помощи методов изложеных ниже, переформатировать ITEA_COURSES в массив который содержит длину строк каждого из элементов.
		  2. Самостоятельно изучить метод Array.sort. Отфильтровать массив ITEA_COURSES по алфавиту.
			  + Бонусный бал. Вывести на страничку списком
		  3. Реализация функции поиска по массиву ITEA_COURSES.
			  + Бонусный бал. Вывести на страничку инпут и кнопку по которой будет срабатывать поиск.
		*/

		const ITEA_COURSES = ["Курс HTML & CSS", "JavaScript базовый курс", "JavaScript продвинутый курс", "JavaScript Professional", "Angular 2.4 (базовый)", "Angular 2.4 (продвинутый)", "React.js", "React Native", "Node.js", "Vue.js"];

		let arr = [];

		ITEA_COURSES.forEach(v => {
			arr.push(v.length)
		})

		console.log(arr);
		

		/*
		  Задание 2:
		  Написать фильтр массива по:
		  Актеру, продолжительности
	  
		  Бонус:
			Сделать графическую оболочку для программы:
			- Селект со списком актеров
			- Селект или инпут с продолжительностью
			- Результат в виде списка фильмов
		*/

		var stars = ['Elijah Wood', 'Ian McKellen', 'Orlando Bloom', 'Ewan McGregor', ' Liam Neeson', 'Natalie Portman', 'Ewan McGregor', 'Billy Bob Thornton', 'Martin Freeman']
		var movies = [
			{
				name: "Lord of the Rigs",
				duration: 240,
				starring: ['Elijah Wood', 'Ian McKellen', 'Orlando Bloom']
			},
			{
				name: "Star Wars: Episode I - The Phantom Menace",
				duration: 136,
				starring: ['Ewan McGregor', ' Liam Neeson', 'Natalie Portman']
			},
			{
				name: "Fargo",
				duration: 100,
				starring: ['Ewan McGregor', 'Billy Bob Thornton', 'Martin Freeman']
			},
			{
				name: "V for Vendetta",
				duration: 150,
				starring: ['Hugo Weaving', 'Natalie Portman', 'Rupert Graves']
			}
		];



		let actorBlock = document.querySelector('#actors');
		let rezBlock = document.querySelector('#rez');
		let duration = document.querySelector('#duration');
		let all = document.querySelector('#all');

		let selectBuild = () => {
			let actors = () => {
				let templateActor = (a) => {
					return `<option value="${a}">${a}</option>`
				}
				let items = '';

				stars.filter(v => {
					items += templateActor(v)
				})

				return items
			}

			let template = () => {
				return `
					<select>
						<option disabled selected>выбрать актора</option>
						${actors()}
					</select>
				`
			};
			actorBlock.innerHTML = template();
		}

		selectBuild();


		let templateActors = {
			items: (list) => {
				let templateActor = (a) => {
					return `<ul>${a}</ul>`
				}
				let items = '';

				list.forEach(v => {
					items += templateActor(v)
				})

				return items
			},
			list: (a) => {
				return `
					<li>
						<p>${a.name}</p>
						<p>${a.duration}</p>
						<ul>${templateActors.items(a.starring)}</ul>
					</li>
				`
			}
		}

		let filmsBuild = (list ,self) => {
			let listFilms = document.createElement('ul');
			rezBlock.innerHTML = '';
			
			list.forEach(v => {
				if (self) {
					v.starring.forEach(a => {
						if (self.value == a) {
							listFilms.innerHTML += templateActors.list(v)
							rezBlock.appendChild(listFilms)
						}
					})
				} else {
					listFilms.innerHTML += templateActors.list(v)
					rezBlock.appendChild(listFilms)
				}
				
			})
		}

		actorBlock.querySelector('select').addEventListener('change', function () {
			let self = this;
			filmsBuild(movies, self)
		})

		filmsBuild(movies);

		all.addEventListener('click', () => {
			filmsBuild(movies);
		})


		

		duration.addEventListener('click', () => {
			let durArr = [];
			movies.forEach(v => {
				durArr.push(v.duration)
			})
			function sortnum(a, b) {
				return parseInt(a, 10) - parseInt(b, 10);
			}
			let durArrSort = durArr.sort(sortnum)
			let newMovies = [];
			durArrSort.forEach((b) => {
				movies.filter((a) => {
					if(b == a.duration) {
						newMovies.push(a)
					}
				})
				
			})
			filmsBuild(newMovies);
		})


	</script>
</body>

</html>